//+------------------------------------------------------------------+
//|                                      MoneyFixedLotWithSignal.mqh |
//|                                Copyright 2012, Victor A.Kirillin |
//+------------------------------------------------------------------+
#include <Expert\Money\MoneyFixedLot.mqh>
#include <Expert\ExpertSignal.mqh>
// wizard description start
//+------------------------------------------------------------------+
//| Description of the class                                         |
//| Title=Trading with fixed trade volume with CExperSignal          |
//| Type=Money                                                       |
//| Name=FixLotWithSignal                                            |
//| Class=CMoneyFixedLotWithSignal                                   |
//| Page=                                                            |
//| Parameter=Percent,double,10.0,Percent                            |
//| Parameter=Lots,double,0.1,Fixed volume                           |
//+------------------------------------------------------------------+
// wizard description end
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CMoneyFixedLotWithSignal : public CMoneyFixedLot
  {
private:
   CExpertSignal*    m_signal;

public:
                     CMoneyFixedLotWithSignal(void);
                    ~CMoneyFixedLotWithSignal(void);
   //---
   void              Signal(CExpertSignal* signal) { m_signal=signal; }
   //---
   virtual double    CheckOpenLong(double price,double sl);
   virtual double    CheckOpenShort(double price,double sl);

protected:
   double            SignalDirection(void);
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
CMoneyFixedLotWithSignal::CMoneyFixedLotWithSignal(void) : m_signal(NULL)
  {
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
CMoneyFixedLotWithSignal::~CMoneyFixedLotWithSignal(void)
  {
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double CMoneyFixedLotWithSignal::SignalDirection(void)
  {
   if(m_signal==NULL) return(0.0);
//---
   return(m_signal.Direction());
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double CMoneyFixedLotWithSignal::CheckOpenLong(double price,double sl)
  {
   if(SignalDirection()<0.0) return(0.0);
//---
   return(CMoneyFixedLot::CheckOpenLong(price,sl));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double CMoneyFixedLotWithSignal::CheckOpenShort(double price,double sl)
  {
   if(SignalDirection()>0.0) return(0.0);
//---
   return(CMoneyFixedLot::CheckOpenShort(price,sl));
  }
//+------------------------------------------------------------------+
